#include "temp.h"
#include "GramServer.h"
#include "PackObject.h"
#include "globus_toolkit.h"
#include "GramServerBase.h"


int componentStartpointMethodID = 175;
int catInstantiateMethodID = 242;
int rebindRegistryMethodID = 101;
int bindRegistryMethodID = 102;
int getNameMethodIDofComponent = 224;

GramServer :: GramServer() {

  //register all member methods that will be invoked

  int FID1 = hpcxx_register(GramServer::instantiateComponent, catInstantiateMethodID);
  int FID2 = hpcxx_register(GramServerBase::returnStartpoint, componentStartpointMethodID);
  //  int FID3 = hpcxx_register(RMIRegistry<GramServer>::bindRegistry, bindRegistryMethodID);
  int FID4 = hpcxx_register(RMIRegistry<GramServer>::rebindRegistry, rebindRegistryMethodID);
  int FID5 = hpcxx_register(GramServerBase::getName, getNameMethodIDofComponent);

  int CID1 = hpcxx_registerClass((GramServer *) NULL);
  int CID2 = hpcxx_registerClass((RMIRegistry<GramServer> *) NULL);
  int CID3 = hpcxx_registerClass((Component *) NULL);


  int returnValue = gs_init();
  if (returnValue) {
    cout << "gs_init() failed !!! returnValue\t: " << returnValue << endl;
    cout << " ... Exiting ...\n" << endl;
    exit(EXIT_FAILURE);
  }
}

  // globus related stuff so that 
  // an HPC++ component can be instantiated
  // the component resides in path
  // the component needs to be instantiated on machineToRunOn

MyHPCxx_GlobalPtr<Component>  GramServer :: instantiateComponent(HPCxx_String gatekeeperMachine, HPCxx_String machineToRunOn, HPCxx_String path,  HPCxx_String FQN) {

  signal(10, SIG_DFL);
  PackObject packer;
  HPCxx_ContextID *mCID = new HPCxx_ContextID();
  
  cout << endl <<  "GramServer :: instantiateComponent " << endl ;
  cout << "path = " <<   path << endl;
  cout << "machineToRunOn : " <<  machineToRunOn << endl ;
  cout << "gateKeeperMachine : " << gatekeeperMachine << endl ;
  cout << "FQN : " <<  FQN << endl  << endl ;

  // Return NULL info if remoteSP is NULL
  Component *component = new Component();

  // check the return value !!
  hpcxx_connectContext(gatekeeperMachine); 

   globus_nexus_startpoint_t *remoteSP = (globus_nexus_startpoint_t *)hpcxx_createContext(machineToRunOn, path);
  //  globus_nexus_startpoint_t *remoteSP = NULL;
  

  if (remoteSP == NULL)  {
 //   nexus_startpoint_destroy(remoteSP);
    printf("\n NULL remoteSP  received by the Gram Server ");
    printf("\n Please look at the error list in $(GLOBUS)/include/globus_gram_client.h  \n");
    MyHPCxx_GlobalPtr<Component> myNULLPtr(component);
    myNULLPtr.setItAsNULL();
    printf("\n NULL globalPtr is being returned to the CAT !!! \n");
    fflush(NULL);
    return myNULLPtr;
  }

  cout << "\n Obtained startoint to remote process " << endl;
  fflush(NULL);

  HPCxx_GlobalPtr<Component> myProcPtr(component, remoteSP);
  
  hpcxx_minvoke(&myProcPtr, packer, componentStartpointMethodID);
  globus_nexus_startpoint_destroy(remoteSP);
  *mCID=packer.GetContextIDPtr();
  cout << "received startpoint from remote object " << endl;
  fflush(NULL);
  
  MyHPCxx_GlobalPtr<Component> *testObjGP = new MyHPCxx_GlobalPtr<Component>(component, mCID);

  HPCxx_String name("Component");
  cout << "invoking getName method on Component to test it  " << endl;
  fflush(NULL);
  hpcxx_minvoke(testObjGP, name, getNameMethodIDofComponent);
  cout << "returned from the test call to method getName()   " << endl;
  fflush(NULL);
  cout << "minvoke for testcall getName() returned : " << name << endl << flush;
  fflush(NULL);

  testObjGP->setFullyQualifiedFileName(FQN);
  return *testObjGP;
}

GramServer :: ~GramServer() {}


void hpcxx_pack(HPCxx_Buffer &buf, GramServer *t,int count) {}

void hpcxx_unpack(HPCxx_Buffer &buf, GramServer *t,int count) {}

void hpcxx_unpack(HPCxx_Buffer &b, GramServerBase * pw, int count) {}
void hpcxx_pack(HPCxx_Buffer &b, GramServerBase * pw, int count){}

