#ifndef _RMIRegistry_h__
#define _RMIRegistry_h__

#include <hpcxx_rts.h>
#include "temp.h"
//#include <hpcxx_invokeImpl.cc> // already included in Component.h
#include "Constants.h"
#include <sys/utsname.h>
#include <stdlib.h>
#include <unistd.h>
#include <stream.h>
#include <signal.h>
#include <HPCxx_GlobalRef.h>
#include <HPCxx_GlobalRefImpl.h>
#include <HPCxx_Buffer.h>
#include "hpcxx_byte.h"
#include "HPCxx_String.h"
#include "BindObject.h"


template <class T>
class RMIRegistry {
private:
  nexus_startpoint_t registryStartpoint;
  nexus_startpoint_t localStartpoint;  
  nexus_startpoint_t remoteObjStartpoint;  
public:
  RMIRegistry();
  int bindRegistry(HPCxx_GlobalPtr<T> gp, HPCxx_String rmiURL, HPCxx_String FQN);
  int rebindRegistry(HPCxx_GlobalPtr<T> gp, HPCxx_String rmiURL, HPCxx_String FQN);
  void attachToRegistry(char *registryHost, unsigned short port);
  static int registrationID()  { return 355; }
  ~RMIRegistry();
  friend void hpcxx_pack(HPCxx_Buffer &buf, RMIRegistry *t,int count);
  friend void hpcxx_unpack(HPCxx_Buffer &buf, RMIRegistry *t,int count);
};

#endif // _RMIRegistry_h__








